"use strict";

exports.__esModule = true;
exports.default = void 0;

var _command = require("@oclif/command");

var _ = require("../../");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class StartCommand extends _command.Command {
  async run() {
    const {
      flags
    } = this.parse(StartCommand);
    this.log(`Starting daemon with environment ${flags.env}`);
    await (0, _.startServer)(flags.env);
    this.log(`Daemon started`);
    process.on('SIGINT', async () => {
      this.log(`Stopping daemon`);
      await (0, _.stopServer)(flags.env);
      this.log(`Daemon stopped`);
      process.exit(0);
    });
  }

}

exports.default = StartCommand;

_defineProperty(StartCommand, "flags", {
  env: _command.flags.string({
    char: 'e',
    description: 'environment name',
    required: true
  })
});