"use strict";

exports.__esModule = true;
exports.default = void 0;

var _graphql = require("graphql");

var _mutation = _interopRequireDefault(require("./mutation"));

var _objects = require("./objects");

var _subscription = _interopRequireDefault(require("./subscription"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const query = new _graphql.GraphQLObjectType({
  name: 'Query',
  fields: () => ({
    node: _objects.nodeField,
    viewer: {
      type: new _graphql.GraphQLNonNull(_objects.viewer),
      resolve: () => ({})
    },
    peers: {
      type: new _graphql.GraphQLNonNull(_objects.peers),
      resolve: () => ({})
    }
  })
});

var _default = new _graphql.GraphQLSchema({
  mutation: _mutation.default,
  query,
  subscription: _subscription.default
});

exports.default = _default;