"use strict";

exports.__esModule = true;
exports.default = void 0;

var _graphql = require("graphql");

var _operators = require("rxjs/operators");

var _objects = require("./objects");

var _observableToAsyncIterator = _interopRequireDefault(require("./observableToAsyncIterator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const contactChanged = {
  type: new _graphql.GraphQLNonNull(_objects.contact),
  subscribe: (self, args, ctx) => {
    const {
      source,
      dispose
    } = ctx.contactsFeeds.observe();
    const contactChanged = source.pipe((0, _operators.map)(e => ({
      contactChanged: e.contact
    })));
    return (0, _observableToAsyncIterator.default)(contactChanged, dispose);
  }
};

var _default = new _graphql.GraphQLObjectType({
  name: 'Subscription',
  fields: () => ({
    contactChanged
  })
});

exports.default = _default;