"use strict";

exports.__esModule = true;
exports.default = void 0;

var _utilsCrypto = require("@mainframe/utils-crypto");

var _utilsId = require("@mainframe/utils-id");

var _OwnIdentity = _interopRequireWildcard(require("./OwnIdentity"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class OwnAppIdentity extends _OwnIdentity.default {
  constructor(localID, keyPair) {
    super(localID, 'app', keyPair);
  }

}

exports.default = OwnAppIdentity;

_defineProperty(OwnAppIdentity, "create", (keyPair, localID) => {
  return new OwnAppIdentity(localID || (0, _utilsId.uniqueID)(), keyPair || (0, _utilsCrypto.createSignKeyPair)());
});

_defineProperty(OwnAppIdentity, "fromJSON", serialized => {
  return new OwnAppIdentity(serialized.localID, (0, _OwnIdentity.parseKeyPair)(serialized.keyPair));
});

_defineProperty(OwnAppIdentity, "toJSON", identity => ({
  keyPair: (0, _OwnIdentity.serializeKeyPair)(identity.keyPair),
  localID: identity.localID
}));