"use strict";

exports.__esModule = true;
exports.default = void 0;

var _utilsCrypto = require("@mainframe/utils-crypto");

var _utilsId = require("@mainframe/utils-id");

var _OwnIdentity = _interopRequireWildcard(require("./OwnIdentity"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class OwnDeveloperIdentity extends _OwnIdentity.default {
  constructor(localID, keyPair, profile) {
    super(localID, 'dev', keyPair);

    _defineProperty(this, "_profile", void 0);

    this._profile = profile;
  }

  get profile() {
    return this._profile;
  }

}

exports.default = OwnDeveloperIdentity;

_defineProperty(OwnDeveloperIdentity, "create", (profile, keyPair, localID) => {
  return new OwnDeveloperIdentity(localID || (0, _utilsId.uniqueID)(), keyPair || (0, _utilsCrypto.createSignKeyPair)(), profile);
});

_defineProperty(OwnDeveloperIdentity, "fromJSON", serialized => {
  return new OwnDeveloperIdentity(serialized.localID, (0, _OwnIdentity.parseKeyPair)(serialized.keyPair), serialized.profile);
});

_defineProperty(OwnDeveloperIdentity, "toJSON", identity => {
  return {
    localID: identity.localID,
    keyPair: (0, _OwnIdentity.serializeKeyPair)(identity.keyPair),
    profile: identity.profile
  };
});