"use strict";

exports.__esModule = true;
exports.default = void 0;

var _utilsCrypto = require("@mainframe/utils-crypto");

var _utilsId = require("@mainframe/utils-id");

var _feed = require("../swarm/feed");

var _OwnIdentity = _interopRequireWildcard(require("./OwnIdentity"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class OwnUserIdentity extends _OwnIdentity.default {
  constructor(params) {
    super(params.localID, 'user', params.keyPair);

    _defineProperty(this, "_profile", void 0);

    _defineProperty(this, "_publicFeed", void 0);

    _defineProperty(this, "_firstContactFeed", void 0);

    _defineProperty(this, "_privateProfile", void 0);

    this._profile = params.profile;
    this._publicFeed = params.publicFeed;
    this._firstContactFeed = params.firstContactFeed;
    this._privateProfile = params.privateProfile;
  }

  get profile() {
    return this._profile;
  }

  set profile(profile) {
    this._profile = profile;
  }

  get publicFeed() {
    return this._publicFeed;
  }

  get firstContactFeed() {
    return this._firstContactFeed;
  }

  get privateProfile() {
    return this._privateProfile;
  }

  set privateProfile(setPrivate) {
    this._privateProfile = setPrivate;
  }

  publicFeedData() {
    const {
      name,
      avatar,
      ethAddress
    } = this.profile;
    return {
      publicKey: this.base64PublicKey(),
      profile: this.privateProfile ? {} : {
        name,
        avatar,
        ethAddress
      },
      firstContactAddress: this.firstContactFeed.address
    };
  }

}

exports.default = OwnUserIdentity;

_defineProperty(OwnUserIdentity, "create", (profile, privateProfile, keyPair, localID) => {
  return new OwnUserIdentity({
    localID: localID || (0, _utilsId.uniqueID)(),
    keyPair: keyPair || (0, _utilsCrypto.createSignKeyPair)(),
    profile,
    publicFeed: _feed.OwnFeed.create(undefined, 'mf-identity-public-feed'),
    firstContactFeed: _feed.OwnFeed.create(),
    privateProfile: !!privateProfile
  });
});

_defineProperty(OwnUserIdentity, "fromJSON", serialized => new OwnUserIdentity({
  localID: serialized.localID,
  keyPair: (0, _OwnIdentity.parseKeyPair)(serialized.keyPair),
  profile: serialized.profile,
  publicFeed: _feed.OwnFeed.fromJSON(serialized.publicFeed),
  firstContactFeed: _feed.OwnFeed.fromJSON(serialized.firstContactFeed),
  privateProfile: serialized.privateProfile
}));

_defineProperty(OwnUserIdentity, "toJSON", identity => ({
  localID: identity.localID,
  keyPair: (0, _OwnIdentity.serializeKeyPair)(identity.keyPair),
  profile: identity.profile,
  publicFeed: _feed.OwnFeed.toJSON(identity.publicFeed),
  firstContactFeed: _feed.OwnFeed.toJSON(identity.firstContactFeed),
  privateProfile: identity._privateProfile
}));