"use strict";

exports.__esModule = true;
exports.default = void 0;

var _Identity = _interopRequireDefault(require("./Identity"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class PeerUserIdentity extends _Identity.default {
  constructor(localID, keyOrId, profile, publicFeed, firstContactAddress, otherFeeds) {
    super(localID, 'user', keyOrId);

    _defineProperty(this, "_publicFeed", void 0);

    _defineProperty(this, "_firstContactAddress", void 0);

    _defineProperty(this, "_otherFeeds", void 0);

    _defineProperty(this, "_profile", void 0);

    this._publicFeed = publicFeed;
    this._firstContactAddress = firstContactAddress;
    this._otherFeeds = otherFeeds || {};
    this._profile = profile;
  }

  get publicFeed() {
    return this._publicFeed;
  }

  get profile() {
    return this._profile;
  }

  get firstContactAddress() {
    return this._firstContactAddress;
  }

  get otherFeeds() {
    return this._otherFeeds;
  }

  get name() {
    return this._profile.name;
  }

  get avatar() {
    return this._profile.avatar;
  }

  set profile(profile = {}) {
    this._profile = profile;
  }

}

exports.default = PeerUserIdentity;

_defineProperty(PeerUserIdentity, "fromJSON", params => {
  return new PeerUserIdentity(params.localID, params.id, params.profile, params.publicFeed, params.firstContactAddress, params.otherFeeds);
});

_defineProperty(PeerUserIdentity, "toJSON", peer => ({
  id: peer.id,
  localID: peer.localID,
  publicFeed: peer.publicFeed,
  firstContactAddress: peer.firstContactAddress,
  otherFeeds: peer.otherFeeds,
  profile: peer.profile
}));