"use strict";

exports.__esModule = true;
exports.approveContactsForApp = exports.getAppUserContacts = exports.getAppApprovedContacts = exports.getUserContacts = void 0;

var _client = require("@mainframe/client");

const getUserContacts = {
  params: _client.CONTACT_GET_USER_CONTACTS_SCHEMA,
  handler: async (ctx, params) => {
    const contacts = ctx.queries.getUserContacts(params.userID);
    return {
      contacts
    };
  }
};
exports.getUserContacts = getUserContacts;
const getAppApprovedContacts = {
  params: _client.CONTACT_GET_APP_APPROVED_CONTACTS_SCHEMA,
  handler: async (ctx, params) => {
    const contacts = ctx.queries.getAppApprovedContacts(params.appID, params.userID);
    return {
      contacts
    };
  }
};
exports.getAppApprovedContacts = getAppApprovedContacts;
const getAppUserContacts = {
  params: _client.CONTACT_GET_APP_USER_CONTACTS_SCHEMA,
  handler: async (ctx, params) => {
    const contacts = ctx.queries.getAppUserContacts(params.appID, params.userID, params.contactIDs);
    return {
      contacts
    };
  }
};
exports.getAppUserContacts = getAppUserContacts;
const approveContactsForApp = {
  params: _client.CONTACT_APPROVE_CONTACTS_FOR_APP_SCHEMA,
  handler: async (ctx, params) => {
    const approvedContacts = await ctx.mutations.appApproveContacts(params.appID, params.userID, params.contactsToApprove);
    return {
      approvedContacts
    };
  }
};
exports.approveContactsForApp = approveContactsForApp;