"use strict";

exports.__esModule = true;
exports.subscription = exports.query = void 0;

var _client = require("@mainframe/client");

var _graphql = require("graphql");

var _subscription = require("graphql/subscription");

var _ContextSubscriptions = require("../../context/ContextSubscriptions");

var _schema = _interopRequireDefault(require("../../graphql/schema"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncIterator(iterable) { var method; if (typeof Symbol === "function") { if (Symbol.asyncIterator) { method = iterable[Symbol.asyncIterator]; if (method != null) return method.call(iterable); } if (Symbol.iterator) { method = iterable[Symbol.iterator]; if (method != null) return method.call(iterable); } } throw new TypeError("Object is not async iterable"); }

class GraphQLSubscription extends _ContextSubscriptions.ContextSubscription {
  constructor(iterator) {
    super('graphql_subscription_update', iterator);
  }

  async startNotify(notify) {
    if (this.data == null) {
      throw new Error('Invalid subscription');
    }

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;

    var _iteratorError;

    try {
      for (var _iterator = _asyncIterator(this.data), _step, _value; _step = await _iterator.next(), _iteratorNormalCompletion = _step.done, _value = await _step.value, !_iteratorNormalCompletion; _iteratorNormalCompletion = true) {
        const result = _value;

        if (result != null) {
          notify(this.method, {
            subscription: this.id,
            result
          });
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          await _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  async dispose() {
    if (this.data != null) {
      await this.data.return();
    }
  }

}

const query = {
  params: _client.GRAPHQL_QUERY_SCHEMA,
  handler: async (ctx, params) => {
    return (0, _graphql.graphql)(_schema.default, params.query, {}, ctx, params.variables);
  }
};
exports.query = query;
const subscription = {
  params: _client.GRAPHQL_QUERY_SCHEMA,
  handler: async (ctx, params) => {
    // $FlowFixMe: AsyncIterator
    const iterator = await (0, _subscription.subscribe)(_schema.default, (0, _graphql.parse)(params.query), {}, ctx, params.variables);
    const subscription = new GraphQLSubscription(iterator);
    ctx.subscriptions.set(subscription);
    subscription.startNotify(ctx.notify).catch(() => {
      ctx.subscriptions.remove(subscription.id);
    });
    return subscription.id;
  }
};
exports.subscription = subscription;