"use strict";

exports.__esModule = true;
exports.setSettings = exports.open = exports.getSettings = exports.create = void 0;

var _client = require("@mainframe/client");

var _errors = require("../errors");

const create = {
  params: _client.VAULT_SCHEMA,
  handler: async (ctx, params) => {
    try {
      await ctx.mutations.createVault(params.path, Buffer.from(params.password));
    } catch (err) {
      // TODO: different error code depending on actual error
      throw (0, _errors.vaultError)(err.message);
    }
  }
};
exports.create = create;

const getSettings = ctx => {
  return ctx.openVault.settings;
};

exports.getSettings = getSettings;
const open = {
  params: _client.VAULT_SCHEMA,
  handler: async (ctx, params) => {
    try {
      await ctx.mutations.openVault(params.path, Buffer.from(params.password));
    } catch (err) {
      // TODO: different error code depending on actual error
      throw (0, _errors.vaultError)(err.message);
    }
  }
};
exports.open = open;
const setSettings = {
  params: _client.VAULT_SETTINGS_SCHEMA,
  handler: async (ctx, settings) => {
    const newSettings = ctx.openVault.setSettings(settings);
    await ctx.openVault.save();
    return newSettings;
  }
};
exports.setSettings = setSettings;